diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index b0e4368c8..353e0bad8 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -1,12 +1,19 @@
 package org.useless.dragonfly.models.entity.mojang;
 
+import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
 import org.useless.dragonfly.data.entity.mojang.Bone;
 import org.useless.dragonfly.data.entity.mojang.Cube;
 import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
@@ -14,12 +21,14 @@ import org.useless.dragonfly.data.entity.mojang.Face;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-import java.util.HashMap;
+import java.nio.ByteBuffer;
+import java.nio.FloatBuffer;
 import java.util.Map;
 
 public class StaticEntityModelMojang implements StaticEntityModel {
     private static final BoneTransform DUMMY_TRANSFORM = new BoneTransform();
-    public final @NotNull Map<@NotNull String, @NotNull BoneTransform> transformMap = new HashMap<>();
+    private static final TessellatorEntity entityTessellator = new TessellatorEntity(2048);
+    public final @NotNull Map<@NotNull String, @NotNull BoneTransform> transformMap = new Object2ObjectOpenHashMap<>();
     public final @NotNull BoneTransform @NotNull [] transforms;
     public final @NotNull Bone @NotNull [] bones;
     public final EntityGeometryMojangData data;
@@ -73,18 +82,21 @@ public class StaticEntityModelMojang implements StaticEntityModel {
         final Bone bone = this.data.bones.get(boneId);
         if (bone == null) return;
         boneTransform(bone);
-        GL11.glTranslated(bone.pivot[0], bone.pivot[1], bone.pivot[2]);
+        GLRenderer.modelM4f().translate((float) bone.pivot[0], (float) bone.pivot[1], (float) bone.pivot[2]);
     }
 
     @Override
-    public void render(@NotNull final Tessellator tessellator) {
+    public void render() {
+        GLRenderer.getShader().bind();
+        GLRenderer.globalSetUniforms(GLRenderer.getShader());
         for (int i = 0; i < this.bones.length; i++) {
             final Bone bone = this.bones[i];
-            GL11.glPushMatrix();
+            GLRenderer.pushFrame();
             if (!boneTransform(bone)) {
-                renderBone(tessellator, bone);
+                GL41.glUniformMatrix4fv(GLRenderer.getShader().getUniform("model"), false, GLRenderer.modelM4f().get(this.mat4fBuf));
+                renderBone(entityTessellator, bone);
             }
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
     }
 
@@ -96,19 +108,21 @@ public class StaticEntityModelMojang implements StaticEntityModel {
         }
         final BoneTransform transform = this.transformMap.get(bone.name);
         hidden |= !transform.visible;
-        GL11.glTranslated(bone.pivot[0], bone.pivot[1], bone.pivot[2]);
-        GL11.glTranslated(transform.posX, transform.posY, transform.posZ);
-        GL11.glRotated(-(transform.rotZ * MathHelper.RAD_TO_DEG) - bone.rotation[2], 0, 0, 1);
-        GL11.glRotated((transform.rotY * MathHelper.RAD_TO_DEG) + bone.rotation[1], 0, 1, 0);
-        GL11.glRotated(-(transform.rotX * MathHelper.RAD_TO_DEG) - bone.rotation[0], 1, 0, 0);
-        GL11.glTranslated(-bone.pivot[0], -bone.pivot[1], -bone.pivot[2]);
-        GL11.glScaled(transform.scaleX, transform.scaleY, transform.scaleZ);
+        GLRenderer.modelM4f().translate((float) bone.pivot[0], (float) bone.pivot[1], (float) bone.pivot[2]);
+        GLRenderer.modelM4f().translate((float) transform.posX, (float) transform.posY, (float) transform.posZ);
+        GLRenderer.modelM4f().rotateZ((float) (-transform.rotZ - Math.toRadians(bone.rotation[2])));
+        GLRenderer.modelM4f().rotateY((float) (transform.rotY + Math.toRadians(bone.rotation[1])));
+        GLRenderer.modelM4f().rotateX((float) (-transform.rotX - Math.toRadians(bone.rotation[0])));
+        GLRenderer.modelM4f().translate((float) -bone.pivot[0], (float) -bone.pivot[1], (float) -bone.pivot[2]);
+        GLRenderer.modelM4f().scale((float) transform.scaleX, (float) transform.scaleY, (float) transform.scaleZ);
         return hidden;
     }
 
+    private final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(16);
+
     private final double[] uvsBuffer = new double[8];
 
-    protected void renderBone(@NotNull final Tessellator tessellator, @NotNull final Bone bone) {
+    protected void renderBone(@NotNull final TessellatorEntity tessellator, @NotNull final Bone bone) {
         tessellator.startDrawingQuads();
         for (final Cube cube : bone.cubes) {
             final double minX = cube.origin[0] - (cube.inflate + bone.inflate + this.inflation);
@@ -425,7 +439,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
         tessellator.draw();
     }
 
-    protected static void addRotatedVertex(@NotNull final Tessellator tessellator, final double x, final double y, final double z, final double u, final double v, final double @NotNull [] pivot, final double @NotNull [] rotation) {
+    protected static void addRotatedVertex(@NotNull final TessellatorEntity tessellator, final double x, final double y, final double z, final double u, final double v, final double @NotNull [] pivot, final double @NotNull [] rotation) {
         double _x = x - pivot[0];
         double _y = y - pivot[1];
         double _z = z - pivot[2];
@@ -469,4 +483,122 @@ public class StaticEntityModelMojang implements StaticEntityModel {
 
         tessellator.addVertexWithUV(_x + pivot[0], _y + pivot[1], _z + pivot[2], u, v);
     }
+
+    public static class TessellatorEntity {
+        private static final Logger LOGGER = LogUtils.getLogger();
+        private static final int VERT_SIZE = 5 * Float.BYTES + 3;
+        public ByteBuffer data;
+
+        public boolean drawing;
+
+        public byte normalX = 0;
+        public byte normalY = -128;
+        public byte normalZ = 0;
+
+        public final int vao;
+        public final int vbo;
+
+        public int vertexCount = 0;
+        private int quadVertCount = 0;
+
+        public TessellatorEntity(int capacity) {
+            this.data = BufferUtils.createByteBuffer(capacity);
+            this.vao = GL41.glGenVertexArrays();
+            this.vbo = GL41.glGenBuffers();
+
+            GL41.glBindVertexArray(this.vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+
+            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, 0);
+            GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
+            GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, VERT_SIZE, Float.BYTES * 3);
+            GL41.glVertexAttrib2f(3, 15.5f/16f, 15.5f/16f);
+            GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, VERT_SIZE, Float.BYTES * 5);
+
+            GL41.glEnableVertexAttribArray(0);
+            GL41.glEnableVertexAttribArray(2);
+            GL41.glEnableVertexAttribArray(4);
+        }
+
+        public void startDrawingQuads() {
+            if(this.drawing) {
+                this.drawing = false;
+                throw new IllegalStateException("Entity Tessellator already drawing!");
+            }
+
+            this.normalX = 0;
+            this.normalY = -128;
+            this.normalZ = 0;
+
+            this.vertexCount = 0;
+            this.quadVertCount = 0;
+
+            this.drawing = true;
+
+            this.data.clear();
+        }
+
+        public void addVertexWithUV(double x, double y, double z, double u, double v) {
+            if(!this.drawing) {
+                throw new IllegalStateException("Entity Tessellator already drawing!");
+            }
+            checkCanFit(64);
+
+            this.data.putFloat((float) x).putFloat((float) y).putFloat((float) z);
+            this.data.putFloat((float) u).putFloat((float) v);
+            this.data.put(this.normalX).put(this.normalY).put(this.normalZ);
+
+            this.vertexCount++;
+
+            if (Tessellator.QUAD_EMULATION && this.quadVertCount % 4 == 2) {
+                checkCanFit(128);
+                this.data.put(this.data.position(), this.data, this.data.position() - VERT_SIZE * 3, VERT_SIZE);
+                this.data.put(this.data.position() + VERT_SIZE, this.data, this.data.position() - VERT_SIZE, VERT_SIZE);
+                this.data.position(this.data.position() + VERT_SIZE * 2);
+                this.vertexCount += 2;
+            }
+
+            this.quadVertCount++;
+        }
+
+        public void checkCanFit(int size) {
+            if(this.data.capacity() < this.data.position() + size) {
+                int newSize = this.data.capacity() * 2;
+
+                LOGGER.info("Expanding {} Buffer ({} -> {})", "Entity Tessellator", this.data.capacity(), newSize);
+
+                ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
+                this.data.flip();
+                newBuffer.put(this.data);
+                this.data = newBuffer;
+            }
+        }
+
+        public void setNormal(double x, double y, double z) {
+            if(!this.drawing) {
+                throw new IllegalStateException("Entity Tessellator already drawing!");
+            }
+
+            this.normalX = (byte) (x * 127.0);
+            this.normalY = (byte) (y * 127.0);
+            this.normalZ = (byte) (z * 127.0);
+        }
+
+        public void draw() {
+            if(!this.drawing) {
+                throw new IllegalStateException("Entity Tessellator already drawing!");
+            }
+
+            this.drawing = false;
+
+            if (this.vertexCount == 0) return;
+
+            GL41.glBindVertexArray(this.vao);
+            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
+            GL41.glDrawArrays(Tessellator.QUAD_EMULATION ? DrawMode.TRIANGLES.cap : DrawMode.QUADS.cap, 0, this.vertexCount);
+            GL41.glBindVertexArray(0);
+        }
+    }
 }
diff --git a/game/client/src/main/resources/shaders/clouds.fsh b/game/client/src/main/resources/shaders/clouds.fsh
index b246f1317..00746bf35 100644
--- a/game/client/src/main/resources/shaders/clouds.fsh
+++ b/game/client/src/main/resources/shaders/clouds.fsh
@@ -1,23 +1,30 @@
-#version 120
+#version 410 core
 
 #define FOG
 #define RADIAL_FOG
 
-uniform sampler2D texture;
-
 uniform int isEyeInLiquid;
 
-#ifdef RADIAL_FOG
-uniform mat4 gbufferProjectionInverse;
+uniform mat4 projectionInv;
 uniform float viewWidth;
 uniform float viewHeight;
-#endif
 
-varying vec2 texcoord;
-varying vec4 color;
+in vec4 Color;
+in vec2 TexCoord;
+
+out vec4 FragColor;
+
+uniform vec4 ufogColor;
+uniform int ufogMode;
+uniform float ufogStart;
+uniform float ufogEnd;
+uniform float ufogDensity;
+
+uniform sampler2D texture0;
+uniform sampler2D texture1;
 
 void main() {
-	vec4 tex = texture2D(texture, texcoord);
+	vec4 tex = texture(texture0, TexCoord);
 	
 	// Alpha test
 	if(tex.a < 0.1f) {
@@ -29,30 +36,22 @@ void main() {
 		discard;
 	}
 	
-	vec4 col = color;
-	
-	#ifdef FOG
+	vec4 col = Color;
+
 	float fogStrength = 0.0f;
-	
-	#ifndef RADIAL_FOG
-	fogStrength = (gl_FogFragCoord - gl_Fog.start) * gl_Fog.scale;
-	#endif
-	
-	#ifdef RADIAL_FOG
-	vec4 fragPos = gbufferProjectionInverse * vec4((gl_FragCoord.xy / vec2(viewWidth, viewHeight)) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+
+	vec4 fragPos = projectionInv * vec4((gl_FragCoord.xy / vec2(viewWidth, viewHeight)) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
 	fragPos /= fragPos.w;
 	
 	float dist = length(fragPos.xyz);
-	float end = gl_Fog.end;
-	float start = gl_Fog.start / gl_Fog.end;
-	
+	float end = (ufogEnd * 1.5f);
+	float start = ufogStart / (ufogEnd * 1.5f);
+
 	fogStrength = dist / end;
-	fogStrength -= (start);
+	fogStrength -= start;
 	fogStrength /= (1.0f - start);
 	fogStrength = clamp(fogStrength, 0.0f, 1.0f);
-	#endif
 	col.a *= 1.0f - fogStrength;
-	#endif
 	
-	gl_FragData[0] = tex * col;
+	FragColor = tex * col;
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/clouds.vsh b/game/client/src/main/resources/shaders/clouds.vsh
index 0a5f716c5..ec9b57fd0 100644
--- a/game/client/src/main/resources/shaders/clouds.vsh
+++ b/game/client/src/main/resources/shaders/clouds.vsh
@@ -1,12 +1,20 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 2) in vec2 aUV;
+//layout (location = 3) in vec2 aLightmap;
+//layout (location = 4) in vec3 aNormal;
 
-varying vec2 texcoord;
-varying vec4 color;
+out vec4 Color;
+out vec2 TexCoord;
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
 
 void main() {
-	texcoord = gl_MultiTexCoord0.xy;
-	color = gl_Color;
-	
-	gl_Position = ftransform();
-	gl_FogFragCoord = gl_Position.z;
+	TexCoord = aUV;
+	Color = aColor;
+
+	gl_Position = projection * view * model * vec4(aPos, 1);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/color.fsh b/game/client/src/main/resources/shaders/color.fsh
new file mode 100644
index 000000000..a0dabc0a1
--- /dev/null
+++ b/game/client/src/main/resources/shaders/color.fsh
@@ -0,0 +1,11 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+
+uniform vec4 ucolor;
+
+void main() {
+    FragColor = Color * ucolor;
+}
diff --git a/game/client/src/main/resources/shaders/color.vsh b/game/client/src/main/resources/shaders/color.vsh
new file mode 100644
index 000000000..963b1691f
--- /dev/null
+++ b/game/client/src/main/resources/shaders/color.vsh
@@ -0,0 +1,14 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+
+out vec4 Color;
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
+
+void main() {
+    gl_Position = projection * view * model * vec4(aPos, 1);
+    Color = aColor;
+}
diff --git a/game/client/src/main/resources/shaders/color_world.fsh b/game/client/src/main/resources/shaders/color_world.fsh
new file mode 100644
index 000000000..a3c438d38
--- /dev/null
+++ b/game/client/src/main/resources/shaders/color_world.fsh
@@ -0,0 +1,60 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 LightMapCoord;
+in float Distance;
+in vec3 Light;
+
+uniform vec4 ucolor;
+
+uniform vec4 ufogColor;
+uniform int ufogMode;
+uniform float ufogStart;
+uniform float ufogEnd;
+uniform float ufogDensity;
+
+uniform sampler2D texture1;
+
+// Taken from https://github.com/hughsk/glsl-fog
+float fogFactorLinear() {
+    return 1.0 - clamp(((ufogEnd - (Distance)) / (ufogEnd - ufogStart)), 0.0, 1.0);
+}
+
+float fogFactorExp() {
+    return 1.0 - clamp(exp(-ufogDensity * (Distance)), 0.0, 1.0);
+}
+
+float fogFactorExp2() {
+    float LOG2 = -1.442695;
+    float d = ufogDensity * (Distance);
+    return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
+}
+
+
+vec4 computeFog(vec4 color) {
+    float f = 0;
+    if (ufogMode == 0) { // Linear
+        f = fogFactorLinear();
+    }
+    else if (ufogMode == 1) { // EXP
+        f = fogFactorExp();
+    }
+    else if (ufogMode == 2) { // EXP2
+        f = fogFactorExp2();
+    }
+    return vec4(mix(color.rgb, ufogColor.rgb, f), color.a);
+}
+
+void main() {
+    vec4 lightColor = texture(texture1, LightMapCoord);
+
+    vec4 oColor = lightColor * Color * ucolor;
+    vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
+
+    FragColor = computeFog(oColor);
+    if (FragColor.a < 0.1f) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/color_world.vsh b/game/client/src/main/resources/shaders/color_world.vsh
new file mode 100644
index 000000000..6eec498b0
--- /dev/null
+++ b/game/client/src/main/resources/shaders/color_world.vsh
@@ -0,0 +1,36 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 3) in vec2 aLightmap;
+layout (location = 4) in vec3 aNormal;
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+out float Distance;
+out vec3 Light;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition[];
+uniform vec4 lightSourceDiffuse[];
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
+
+void main() {
+    vec4 p = vec4(aPos, 1);
+    gl_Position = projection * view * model * p;
+
+    Color = aColor;
+    LightMapCoord = aLightmap;
+
+    // Used for the radial fog in shader
+    Distance = length((view * model * p).xyz);
+
+    vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
+    float dir1 = max(0.0f, dot(norm, lightSourcePosition[0]));
+    float dir2 = max(0.0f, dot(norm, lightSourcePosition[1]));
+    Light = (lightModelAmbient + lightSourceDiffuse[0] * (dir1 + dir2)).xyz;
+}
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
new file mode 100644
index 000000000..969fa5cdb
--- /dev/null
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -0,0 +1,18 @@
+#version 410 core
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+in vec2 Lightmap;
+
+uniform vec4 ucolor;
+
+uniform sampler2D texture0;
+uniform sampler2D texture1;
+
+void main() {
+    FragColor = texture(texture0, TexCoord) * texture(texture1, Lightmap) * Color * ucolor;
+    if (FragColor.a < 0.1f) {
+        discard;
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/font.gsh b/game/client/src/main/resources/shaders/font.gsh
new file mode 100644
index 000000000..0cf0dc235
--- /dev/null
+++ b/game/client/src/main/resources/shaders/font.gsh
@@ -0,0 +1,43 @@
+#version 410 core
+layout (points) in;
+layout (triangle_strip, max_vertices = 4) out;
+
+in VS_OUT {
+    vec2 size;
+    float shift;
+    vec4 color;
+    vec2 uv;
+    vec2 uvSizes;
+    vec2 lightmap;
+} gs_in[];
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 Lightmap;
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
+
+void main() {
+    Color = gs_in[0].color;
+    Lightmap = gs_in[0].lightmap;
+
+    TexCoord = gs_in[0].uv + vec2(0, gs_in[0].uvSizes.y);
+    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(-gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
+    EmitVertex();
+
+    TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, gs_in[0].uvSizes.y);
+    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x - gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
+    EmitVertex();
+
+    TexCoord = gs_in[0].uv + vec2(0, 0);
+    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(gs_in[0].shift, 0, 0.0, 0.0));
+    EmitVertex();
+
+    TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, 0);
+    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x + gs_in[0].shift, 0, 0.0, 0.0));
+    EmitVertex();
+
+    EndPrimitive();
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/font.vsh b/game/client/src/main/resources/shaders/font.vsh
new file mode 100644
index 000000000..3c9e8bb1a
--- /dev/null
+++ b/game/client/src/main/resources/shaders/font.vsh
@@ -0,0 +1,30 @@
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aSize;
+layout (location = 2) in float aShift;
+layout (location = 3) in vec4 aColor;
+layout (location = 4) in vec2 aUv;
+layout (location = 5) in vec2 aUvSizes;
+layout (location = 6) in vec2 aLightmap;
+
+out VS_OUT {
+    vec2 size;
+    float shift;
+    vec4 color;
+    vec2 uv;
+    vec2 uvSizes;
+    vec2 lightmap;
+} vs_out;
+
+uniform float uZ;
+
+void main() {
+    gl_Position = vec4(aPos, uZ, 1);
+
+    vs_out.size = aSize;
+    vs_out.shift = aShift;
+    vs_out.color = aColor;
+    vs_out.uv = aUv;
+    vs_out.uvSizes = aUvSizes;
+    vs_out.lightmap = aLightmap;
+}
diff --git a/game/client/src/main/resources/shaders/interface.fsh b/game/client/src/main/resources/shaders/interface.fsh
new file mode 100644
index 000000000..ded77c9ca
--- /dev/null
+++ b/game/client/src/main/resources/shaders/interface.fsh
@@ -0,0 +1,13 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+
+uniform vec4 ucolor;
+uniform sampler2D texture0;
+
+void main() {
+    FragColor = texture(texture0, TexCoord) * Color * ucolor;
+}
diff --git a/game/client/src/main/resources/shaders/interface.vsh b/game/client/src/main/resources/shaders/interface.vsh
new file mode 100644
index 000000000..1df6d673c
--- /dev/null
+++ b/game/client/src/main/resources/shaders/interface.vsh
@@ -0,0 +1,18 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 2) in vec2 aUV;
+
+out vec4 Color;
+out vec2 TexCoord;
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
+
+void main() {
+    gl_Position = projection * view * model * vec4(aPos, 1);
+
+    TexCoord = aUV;
+    Color = aColor;
+}
diff --git a/game/client/src/main/resources/shaders/lines.fsh b/game/client/src/main/resources/shaders/lines.fsh
new file mode 100644
index 000000000..8b8fb3a78
--- /dev/null
+++ b/game/client/src/main/resources/shaders/lines.fsh
@@ -0,0 +1,12 @@
+#version 410 core
+out vec4 FragColor;
+
+in vec4 Color;
+uniform vec4 ucolor;
+
+void main() {
+    FragColor = Color * ucolor;
+    if (FragColor.a < 0.1f) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/lines.gsh b/game/client/src/main/resources/shaders/lines.gsh
new file mode 100644
index 000000000..811cb2e7a
--- /dev/null
+++ b/game/client/src/main/resources/shaders/lines.gsh
@@ -0,0 +1,40 @@
+#version 410 core
+layout (lines) in;
+layout (triangle_strip, max_vertices = 4) out;
+
+in VS_OUT {
+    vec4 color;
+} gs_in[];
+
+out vec4 Color;
+
+uniform float viewWidth;
+uniform float viewHeight;
+uniform float uLineWidth;
+
+void main()
+{
+    vec4 p1 = gl_in[0].gl_Position;
+    vec4 p2 = gl_in[1].gl_Position;
+
+    vec2 dir    = normalize((p2.xy/p2.w - p1.xy/p1.w) * vec2(viewWidth, viewHeight));
+    vec2 offset = vec2(-dir.y, dir.x) * uLineWidth / vec2(viewWidth, viewHeight);
+
+    Color = gs_in[0].color;
+    gl_Position = p1 + vec4(offset.xy * p1.w, 0.0, 0.0);
+    EmitVertex();
+
+    Color = gs_in[0].color;
+    gl_Position = p1 - vec4(offset.xy * p1.w, 0.0, 0.0);
+    EmitVertex();
+
+    Color = gs_in[1].color;
+    gl_Position = p2 + vec4(offset.xy * p2.w, 0.0, 0.0);
+    EmitVertex();
+
+    Color = gs_in[1].color;
+    gl_Position = p2 - vec4(offset.xy * p2.w, 0.0, 0.0);
+    EmitVertex();
+
+    EndPrimitive();
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/lines.vsh b/game/client/src/main/resources/shaders/lines.vsh
new file mode 100644
index 000000000..e88cd1228
--- /dev/null
+++ b/game/client/src/main/resources/shaders/lines.vsh
@@ -0,0 +1,18 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+
+
+out VS_OUT {
+    vec4 color;
+} vs_out;
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
+
+void main() {
+    gl_Position = projection * view * model * vec4(aPos, 1);
+
+    vs_out.color = aColor;
+}
diff --git a/game/client/src/main/resources/shaders/particle.fsh b/game/client/src/main/resources/shaders/particle.fsh
index 84c62fb8a..f7ffa5db6 100644
--- a/game/client/src/main/resources/shaders/particle.fsh
+++ b/game/client/src/main/resources/shaders/particle.fsh
@@ -5,10 +5,12 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 Lightmap;
 
-uniform float partialTick;
 uniform sampler2D texture0;
 uniform sampler2D texture1;
 
 void main() {
     FragColor = texture(texture0, TexCoord) * texture(texture1, Lightmap) * Color;
+    if (FragColor.a < 0.1f) {
+        discard;
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/blur/post.fsh b/game/client/src/main/resources/shaders/photo/blur/post.fsh
index f4d556b12..f21919af8 100644
--- a/game/client/src/main/resources/shaders/photo/blur/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/blur/post.fsh
@@ -1,4 +1,6 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 
@@ -6,7 +8,6 @@ uniform float width;
 uniform float height;
 uniform float intensity;
 
-varying vec2 texcoord;
 
 vec3 getBlur(){
 	vec3 blur = vec3(0.0);
@@ -19,7 +20,7 @@ vec3 getBlur(){
 		for(int j=0; j < q; j++){
 			float strength = 1 - sin(length(vec2(i - qh, j - qh)) / qh);
 			
-			blur += texture2D(colortex0, texcoord + vec2(i - qh, j - qh) * pixel).rgb * strength;
+			blur += texture(colortex0, TexCoords + vec2(i - qh, j - qh) * pixel).rgb * strength;
 			
 			allStrengths += strength;
 		}
@@ -29,9 +30,9 @@ vec3 getBlur(){
 }
 
 void main(){
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 
-	float blurFactor = clamp(distance(texcoord, vec2(0.5)) * 1.0, 0.0, 1.0);
+	float blurFactor = clamp(distance(TexCoords, vec2(0.5)) * 1.0, 0.0, 1.0);
 	vec3 blur = getBlur();
 
 	//Apply Blur
@@ -44,5 +45,5 @@ void main(){
 	//Bloom
 	//color = color * 0.93 + clamp(pow(blur, vec3(2.0)), 0.0, 1.0) * 0.4;
 	
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/blur/post.vsh b/game/client/src/main/resources/shaders/photo/blur/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/blur/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/blur/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/distantblur/post.fsh b/game/client/src/main/resources/shaders/photo/distantblur/post.fsh
index e78f7a680..611e72dfe 100644
--- a/game/client/src/main/resources/shaders/photo/distantblur/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/distantblur/post.fsh
@@ -1,4 +1,6 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 uniform sampler2D depthtex0;
@@ -7,7 +9,6 @@ uniform float intensity;
 uniform float width;
 uniform float height;
 
-varying vec2 texcoord;
 
 vec3 getBlur(){
 	vec3 blur = vec3(0.0);
@@ -20,7 +21,7 @@ vec3 getBlur(){
 		for(int j=0; j < q; j++){
 			float strength = 1 - sin(length(vec2(i - qh, j - qh)) / qh);
 			
-			blur += texture2D(colortex0, texcoord + vec2(i - qh, j - qh) * pixel).rgb * strength;
+			blur += texture(colortex0, TexCoords + vec2(i - qh, j - qh) * pixel).rgb * strength;
 			
 			allStrengths += strength;
 		}
@@ -31,8 +32,8 @@ vec3 getBlur(){
 
 void main()
 {
-	vec3 color = texture2D(colortex0, texcoord).rgb;
-	float depth = texture2D(depthtex0, texcoord).r;
+	vec3 color = texture(colortex0, TexCoords).rgb;
+	float depth = texture(depthtex0, TexCoords).r;
 
 	depth = (depth - (0.45 + 0.1 * (1.0 - intensity))) * 20;
 
@@ -42,5 +43,5 @@ void main()
 	//color = vec3(depth);
 	//color = blur;
 	
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/distantblur/post.vsh b/game/client/src/main/resources/shaders/photo/distantblur/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/distantblur/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/distantblur/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/eerie/post.fsh b/game/client/src/main/resources/shaders/photo/eerie/post.fsh
index 6173bcd20..5889c6c91 100644
--- a/game/client/src/main/resources/shaders/photo/eerie/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/eerie/post.fsh
@@ -1,22 +1,22 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 
 uniform float intensity;
 
-varying vec2 texcoord;
-
 void main(){
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 	
 	float grayscale = (color.r + color.g + color.b) / 3.0;
 	
 	color = mix(color, vec3(grayscale), 0.5 * intensity);
 	
-	float vignette = length(vec2(texcoord - 0.5));
+	float vignette = length(vec2(TexCoords - 0.5));
 	vignette = clamp((vignette - 0.4) * 3, 0.0, 1.0);
 	
 	color = mix(color, vec3(0.0), vignette);
 	
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/eerie/post.vsh b/game/client/src/main/resources/shaders/photo/eerie/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/eerie/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/eerie/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/inverted/post.fsh b/game/client/src/main/resources/shaders/photo/inverted/post.fsh
index 57be58d11..15d45caa2 100644
--- a/game/client/src/main/resources/shaders/photo/inverted/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/inverted/post.fsh
@@ -1,15 +1,15 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 
 uniform float intensity;
 
-varying vec2 texcoord;
-
 void main(){
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 
 	color = mix(color, vec3(1.0 - color.r, 1.0 - color.g, 1.0 - color.b), intensity);
 
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
